﻿using Syncfusion.PivotAnalysis.Base;
using Syncfusion.Windows.Forms;
using Syncfusion.Windows.Forms.Grid.Grouping;
using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.IO;
using System.Linq;
using System.Text;
using System.Windows.Forms;
using System.Xml;
using System.Xml.Serialization;
using Syncfusion.PivotConverter;
 


namespace CashFlowManager
{
    public partial class Form1 : Form
    {

        List<project> projects;
        List<cashflowItem> cashflowReceivables;
        List<cashflowItem> cashflowExpenses;
        List<cashflowItemMonth> cashflowMonths;
        List<VATReceivableExpense> VATReceivableExpenses;
        public Form1()
        {

            InitializeComponent();
            gridGroupingControl1.DataSource = projectBindingSource;

            projects = new List<project>();
            cashflowReceivables = new List<cashflowItem>();
            cashflowExpenses = new List<cashflowItem>();
            cashflowMonths = new List<cashflowItemMonth>();
            VATReceivableExpenses = new List<VATReceivableExpense>();
            projectBindingSource.DataSource = projects;

            cashflowItemMonthBindingSource.DataSource = cashflowMonths;
           
            setGridApp(this.gridGroupingControl1);

            PivotGridSettings();
          
        }
        private void PivotGridSettings()
        {
              
        }

   
        private void btnAddProject_Click(object sender, EventArgs e)
        {
            splitContainerAdv2.Hide();

            var p = new project();
            var formAddEditProject = new FormAddEditProject(p, false,true);
            formAddEditProject.FormClosed += new FormClosedEventHandler(formAddEditProject_FormClosed);
            formAddEditProject.TopLevel = false;
            formAddEditProject.Dock = DockStyle.Fill;
            splitContainerAdv1.Panel2.Controls.Add(formAddEditProject);

            formAddEditProject.Show();
          
        }

        void formAddEditProject_FormClosed(object sender, FormClosedEventArgs e)
        {
            var frm = sender as FormAddEditProject;
            if (frm.update)
            {
                if (!frm.isEdit)
                {
                    frm.prj.created = DateTime.Now;
                      projectBindingSource.CurrencyManager.List.Add(frm.prj);
                }
                else
                {

                    frm.prj.modified = DateTime.Now;
                    var pOld = projectBindingSource.Current as project;
                     frm.prj.Copy(ref pOld);
                    
                    gridGroupingControl1.Table.Reload();
                    gridGroupingControl1.Refresh();

                }
              
            }
            else
            {
                var pOld = projectBindingSource.Current as project;
            }

            splitContainerAdv2.Show();
        }

        private void btnEditProject_Click(object sender, EventArgs e)
        {
            var p = projectBindingSource.Current as project;

            if (p == null)
            {
                return;

            }
            splitContainerAdv2.Hide();
            var formAddEditProject = new FormAddEditProject(p, true, false);
            formAddEditProject.FormClosed += new FormClosedEventHandler(formAddEditProject_FormClosed);
            formAddEditProject.TopLevel = false;
            formAddEditProject.Dock = DockStyle.Fill;
            splitContainerAdv1.Panel2.Controls.Add(formAddEditProject);

            formAddEditProject.Show();

        }

        private void btnDeleteProject_Click(object sender, EventArgs e)
        {
            var p = projectBindingSource.Current as project;

            if (p == null)
            {
                return;

            }
            projectBindingSource.RemoveCurrent();
        }


        private void btnCalc_Click(object sender, EventArgs e)
        {


        }

        private void splitContainerAdv2_VisibleChanged(object sender, EventArgs e)
        { 
                foreach (var ctl in splitContainerAdv1.Panel1.Controls)
                {
                    var ctlb = ctl as ButtonAdv;
                    if (ctlb!=null)
                    {
                       ctlb.Enabled=splitContainerAdv2.Visible;
                    }
                }
            
        }

        void setGridApp(GridGroupingControl grid)
        {

            grid.BrowseOnly = true;
            grid.TableDescriptor.AllowNew = false;
            grid.TableDescriptor.AllowEdit = false;
            grid.TableDescriptor.AllowRemove = false;
            grid.TableDescriptor.ForceEmptyRelations = true;

            grid.TopLevelGroupOptions.ShowFilterBar = false;

            grid.EnableAutoSize = true;
            grid.AllowProportionalColumnSizing = true;
        }
         
        private void btnSave_Click(object sender, EventArgs e)
        {

        }

        private void btnLoad_Click(object sender, EventArgs e)
        {
        }

        private void btnExportToExcel_Click(object sender, EventArgs e)
        {
            bool ExportAsPivotTable;
            ExportAsPivotTable = true;

            SaveFileDialog savedialog = new SaveFileDialog();
            savedialog.AddExtension = true;
            savedialog.FileName = "cashflow";
            savedialog.DefaultExt = "xlsx";
            savedialog.Filter = "Excel file (.xlsx)|*.xlsx";

            if (savedialog.ShowDialog() == DialogResult.OK)
            {
                ExcelExport excelExport = new ExcelExport(pivotGridControl1, Syncfusion.XlsIO.ExcelVersion.Excel2010);
                excelExport.ExportMode = (ExportAsPivotTable) ? ExportModes.PivotTable : ExportModes.Cell;
                excelExport.Export(savedialog.FileName);

                if (MessageBox.Show("Export Success! Do you want to open the exported file?", this.Text, MessageBoxButtons.YesNo) == DialogResult.Yes)
                    System.Diagnostics.Process.Start(savedialog.FileName);
            }
        }

        private void button1_Click(object sender, EventArgs e)
        {
            //this.pivotGridControl1.PivotRows.Clear();
            //this.pivotGridControl1.PivotColumns.Clear();
            //this.pivotGridControl1.PivotCalculations.Clear();
            this.pivotGridControl1.ItemSource = null;
           // pivotGridControl1.PivotEngine.Reset();
           
            pivotGridControl1.Refresh(true);
            var cc = this.pivotGridControl1.ItemSource;

           
        }
     
         
           
    }
}

