﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;

namespace CashFlowManager
{
    public enum cashType
    {
        Receivable, Expense
    }

    public class cashflowItemMonth {
        public List<cashflowItem> cashflowItems{ get; set; } 
        public decimal TAmount { get; set; }
        public decimal TVAT { get; set; }

        public string  Name { get; set; } 

    }


    public class VATReceivableExpense
    {
        public string  Name { get; set; }
        public decimal VATAmount { get; set; }
        public DateTime paymentDate { get; set; }  
    }


    public class cashflowItem {

        public string projName { get; set; }
        public string ItemType { get; set; }
        
        public string ReceivableName { get; set; }
        public string ExpenseName { get; set; }
        public string InstallmentName { get; set; }
        public DateTime paymentDate { get; set; }
        public string Date { get; set; }        
        public decimal NETAmount { get; set; }
        public decimal VAT { get; set; }        
    }

    public class FixedVarExpences
    {
        public string Name { get; set; }
        public DateTime invoiceDate { get; set; }
        public DateTime totalPayable { get; set; }
        public DateTime VAT { get; set; }
    }



    public class project
    {
        public string Name { get; set; }
        public DateTime created{ get; set; }
        public DateTime? modified { get; set; }
        
        public List<receivable> Receivables { get; set; }
        public List<expense> Expenses { get; set; }
        public project() {
            this.Receivables = new List<receivable>();
           this.Expenses = new List<expense>();
        }
        public project Clone() {

            var p = new project();

            p.Name = this.Name;
            p.created = this.created;
            p.modified = p.modified;
           
            foreach (var r in this.Receivables)
            {
                var newr = new receivable()
                {
                    Name = r.Name,
                    invoiceDate = r.invoiceDate,
                    payments = r.payments,
                    totalNETPayable = r.totalNETPayable,
                    totalPayable = r.totalPayable,
                    VAT = r.VAT
                };
                newr.payments = new List<payment>();

                if (r.payments!=null)
                {
                   
                    foreach (var i in r.payments)
                    {
                        var newpayment = new payment()
                        {

                            Name = i.Name,
                            Amount = i.Amount,
                            paymentDate = i.paymentDate
                        };
                        newr.payments.Add(newpayment);
                    }
                }
                p.Receivables.Add(newr);
            }

            foreach (var e in this.Expenses)
            {
                var newexp = new expense()
                {

                    Name = e.Name,
                    invoiceDate = e.invoiceDate,
                    NETPayable = e.NETPayable,
                    totalPayable = e.totalPayable,
                    VAT = e.VAT
                };
                p.Expenses.Add(newexp);
            }

            return p;
        }

        internal void Copy(ref project p)
        {
            p.Name = this.Name;
            p.created = this.created;
            p.modified = this.modified;
            p.Expenses = this.Expenses;
            p.Receivables = this.Receivables;
        }
    }


    public class expense
    {
        public string Name { get; set; }
        public DateTime invoiceDate { get; set; }
        public decimal NETPayable { get; set; }
        public decimal totalPayable { get; set; }
        public decimal VAT { get; set; }

    }
    public class receivable
    {

        public string Name { get; set; }
        public DateTime invoiceDate { get; set; }
        public decimal totalNETPayable { get; set; }
        public decimal totalPayable { get; set; }
        public decimal VAT { get; set; }

        public List<payment> payments { get; set; }
    }
    public class payment
    {
        public string Name { get; set; }
        public DateTime paymentDate { get; set; }
        public decimal Amount { get; set; }
        //public decimal VAT { get; set; }

    }
}
